/**
 *
 * This file is auto-generated. Do not edit manually: changes may be erased.
 * Generated by Aqua compiler: https://github.com/fluencelabs/aqua/.
 * If you find any bugs, please write an issue on GitHub: https://github.com/fluencelabs/aqua/issues
 * Aqua version: 0.3.0-224
 *
 */
import { FluencePeer } from '@fluencelabs/fluence';
import {
    ResultCodes,
    RequestFlow,
    RequestFlowBuilder,
    CallParams,
} from '@fluencelabs/fluence/dist/internal/compilerSupport/v1';

// Services

export interface UserStatusDef {
    notifyOnline: (userPeerId: string, isOnline: boolean, callParams: CallParams<'userPeerId' | 'isOnline'>) => void;
    notifyUserAdded: (
        currentUser: { name: string; peer_id: string; relay_id: string },
        isOnline: boolean,
        callParams: CallParams<'currentUser' | 'isOnline'>,
    ) => void;
    notifyUserRemoved: (userPeerId: string, callParams: CallParams<'userPeerId'>) => void;
}

export function registerUserStatus(service: UserStatusDef): void;
export function registerUserStatus(serviceId: string, service: UserStatusDef): void;
export function registerUserStatus(peer: FluencePeer, service: UserStatusDef): void;
export function registerUserStatus(peer: FluencePeer, serviceId: string, service: UserStatusDef): void;
export function registerUserStatus(...args: any) {
    let peer: FluencePeer;
    let serviceId: any;
    let service: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
    } else {
        peer = FluencePeer.default;
    }

    if (typeof args[0] === 'string') {
        serviceId = args[0];
    } else if (typeof args[1] === 'string') {
        serviceId = args[1];
    } else {
        serviceId = 'fluence/fluent-pad/status';
    }

    if (!(args[0] instanceof FluencePeer) && typeof args[0] === 'object') {
        service = args[0];
    } else if (typeof args[1] === 'object') {
        service = args[1];
    } else {
        service = args[2];
    }

    peer.internals.callServiceHandler.use((req, resp, next) => {
        if (req.serviceId !== serviceId) {
            next();
            return;
        }

        if (req.fnName === 'notifyOnline') {
            const callParams = {
                ...req.particleContext,
                tetraplets: {
                    userPeerId: req.tetraplets[0],
                    isOnline: req.tetraplets[1],
                },
            };
            resp.retCode = ResultCodes.success;
            service.notifyOnline(req.args[0], req.args[1], callParams);
            resp.result = {};
        }

        if (req.fnName === 'notifyUserAdded') {
            const callParams = {
                ...req.particleContext,
                tetraplets: {
                    currentUser: req.tetraplets[0],
                    isOnline: req.tetraplets[1],
                },
            };
            resp.retCode = ResultCodes.success;
            service.notifyUserAdded(req.args[0], req.args[1], callParams);
            resp.result = {};
        }

        if (req.fnName === 'notifyUserRemoved') {
            const callParams = {
                ...req.particleContext,
                tetraplets: {
                    userPeerId: req.tetraplets[0],
                },
            };
            resp.retCode = ResultCodes.success;
            service.notifyUserRemoved(req.args[0], callParams);
            resp.result = {};
        }

        next();
    });
}

export interface TextStateDef {
    notifyTextUpdate: (
        changes: string,
        isAuthorized: boolean,
        callParams: CallParams<'changes' | 'isAuthorized'>,
    ) => void;
}

export function registerTextState(service: TextStateDef): void;
export function registerTextState(serviceId: string, service: TextStateDef): void;
export function registerTextState(peer: FluencePeer, service: TextStateDef): void;
export function registerTextState(peer: FluencePeer, serviceId: string, service: TextStateDef): void;
export function registerTextState(...args: any) {
    let peer: FluencePeer;
    let serviceId: any;
    let service: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
    } else {
        peer = FluencePeer.default;
    }

    if (typeof args[0] === 'string') {
        serviceId = args[0];
    } else if (typeof args[1] === 'string') {
        serviceId = args[1];
    } else {
        serviceId = 'fluence/fluent-pad/text-state';
    }

    if (!(args[0] instanceof FluencePeer) && typeof args[0] === 'object') {
        service = args[0];
    } else if (typeof args[1] === 'object') {
        service = args[1];
    } else {
        service = args[2];
    }

    peer.internals.callServiceHandler.use((req, resp, next) => {
        if (req.serviceId !== serviceId) {
            next();
            return;
        }

        if (req.fnName === 'notifyTextUpdate') {
            const callParams = {
                ...req.particleContext,
                tetraplets: {
                    changes: req.tetraplets[0],
                    isAuthorized: req.tetraplets[1],
                },
            };
            resp.retCode = ResultCodes.success;
            service.notifyTextUpdate(req.args[0], req.args[1], callParams);
            resp.result = {};
        }

        next();
    });
}

export interface AppConfigDef {
    getApp: (callParams: CallParams<null>) => {
        history: { peer_id: string; service_id: string };
        user_list: { peer_id: string; service_id: string };
    };
}

export function registerAppConfig(service: AppConfigDef): void;
export function registerAppConfig(serviceId: string, service: AppConfigDef): void;
export function registerAppConfig(peer: FluencePeer, service: AppConfigDef): void;
export function registerAppConfig(peer: FluencePeer, serviceId: string, service: AppConfigDef): void;
export function registerAppConfig(...args: any) {
    let peer: FluencePeer;
    let serviceId: any;
    let service: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
    } else {
        peer = FluencePeer.default;
    }

    if (typeof args[0] === 'string') {
        serviceId = args[0];
    } else if (typeof args[1] === 'string') {
        serviceId = args[1];
    } else {
        serviceId = 'fluence/get-config';
    }

    if (!(args[0] instanceof FluencePeer) && typeof args[0] === 'object') {
        service = args[0];
    } else if (typeof args[1] === 'object') {
        service = args[1];
    } else {
        service = args[2];
    }

    peer.internals.callServiceHandler.use((req, resp, next) => {
        if (req.serviceId !== serviceId) {
            next();
            return;
        }

        if (req.fnName === 'getApp') {
            const callParams = {
                ...req.particleContext,
                tetraplets: {},
            };
            resp.retCode = ResultCodes.success;
            resp.result = service.getApp(callParams);
        }

        next();
    });
}

// Functions

export function addEntry(
    entry: string,
    config?: { ttl?: number },
): Promise<{ entry_id: number; err_msg: string; ret_code: number }>;
export function addEntry(
    peer: FluencePeer,
    entry: string,
    config?: { ttl?: number },
): Promise<{ entry_id: number; err_msg: string; ret_code: number }>;
export function addEntry(...args: any) {
    let peer: FluencePeer;
    let entry: any;
    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        entry = args[1];
        config = args[2];
    } else {
        peer = FluencePeer.default;
        entry = args[0];
        config = args[1];
    }

    let request: RequestFlow;
    const promise = new Promise<{ entry_id: number; err_msg: string; ret_code: number }>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (seq
       (seq
        (seq
         (seq
          (seq
           (seq
            (seq
             (seq
              (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
              (call %init_peer_id% ("getDataSrv" "entry") [] entry)
             )
             (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
            )
            (call %init_peer_id% ("fluence/get-config" "getApp") [] app0)
           )
           (call -relay- ("op" "noop") [])
          )
          (xor
           (seq
            (call -relay- ("op" "noop") [])
            (call app0.$.user_list.peer_id! (app0.$.user_list.service_id! "is_authenticated") [] res0)
           )
           (seq
            (seq
             (call -relay- ("op" "noop") [])
             (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
            )
            (call -relay- ("op" "noop") [])
           )
          )
         )
         (xor
          (call app.$.history.peer_id! (app.$.history.service_id! "add") [entry res0.$.is_authenticated!] res)
          (seq
           (call -relay- ("op" "noop") [])
           (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
          )
         )
        )
        (call -relay- ("op" "noop") [])
       )
       (call %init_peer_id% ("fluence/get-config" "getApp") [] app1)
      )
      (call -relay- ("op" "noop") [])
     )
     (xor
      (seq
       (call -relay- ("op" "noop") [])
       (call app1.$.user_list.peer_id! (app1.$.user_list.service_id! "get_users") [] allUsers)
      )
      (seq
       (call -relay- ("op" "noop") [])
       (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
      )
     )
    )
    (call -relay- ("op" "noop") [])
   )
   (fold allUsers.$.users! user
    (par
     (seq
      (call -relay- ("op" "noop") [])
      (xor
       (mismatch user.$.peer_id! %init_peer_id%
        (xor
         (seq
          (call user.$.relay_id! ("op" "noop") [])
          (xor
           (call user.$.peer_id! ("fluence/fluent-pad/text-state" "notifyTextUpdate") [entry res0.$.is_authenticated!])
           (seq
            (seq
             (seq
              (call user.$.relay_id! ("op" "noop") [])
              (call -relay- ("op" "noop") [])
             )
             (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 4])
            )
            (call -relay- ("op" "noop") [])
           )
          )
         )
         (seq
          (seq
           (call user.$.relay_id! ("op" "noop") [])
           (call -relay- ("op" "noop") [])
          )
          (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 5])
         )
        )
       )
       (null)
      )
     )
     (seq
      (call -relay- ("op" "noop") [])
      (next user)
     )
    )
   )
  )
  (xor
   (call %init_peer_id% ("callbackSrv" "response") [res])
   (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 6])
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 7])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });
                h.on('getDataSrv', 'entry', () => {
                    return entry;
                });
                h.onEvent('callbackSrv', 'response', (args) => {
                    const [res] = args;
                    resolve(res);
                });

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for addEntry');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return promise;
}

export function getHistory(config?: {
    ttl?: number;
}): Promise<{ entries: { body: string; id: number }[]; err_msg: string; ret_code: number }>;
export function getHistory(
    peer: FluencePeer,
    config?: { ttl?: number },
): Promise<{ entries: { body: string; id: number }[]; err_msg: string; ret_code: number }>;
export function getHistory(...args: any) {
    let peer: FluencePeer;

    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        config = args[1];
    } else {
        peer = FluencePeer.default;
        config = args[0];
    }

    let request: RequestFlow;
    const promise = new Promise<{ entries: { body: string; id: number }[]; err_msg: string; ret_code: number }>(
        (resolve, reject) => {
            const r = new RequestFlowBuilder()
                .disableInjections()
                .withRawScript(
                    `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (seq
       (seq
        (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
        (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
       )
       (call %init_peer_id% ("fluence/get-config" "getApp") [] app0)
      )
      (call -relay- ("op" "noop") [])
     )
     (xor
      (seq
       (call -relay- ("op" "noop") [])
       (call app0.$.user_list.peer_id! (app0.$.user_list.service_id! "is_authenticated") [] res0)
      )
      (seq
       (seq
        (call -relay- ("op" "noop") [])
        (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
       )
       (call -relay- ("op" "noop") [])
      )
     )
    )
    (xor
     (call app.$.history.peer_id! (app.$.history.service_id! "get_all") [res0.$.is_authenticated!] res)
     (seq
      (call -relay- ("op" "noop") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
     )
    )
   )
   (call -relay- ("op" "noop") [])
  )
  (xor
   (call %init_peer_id% ("callbackSrv" "response") [res])
   (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 4])
)

                 `,
                )
                .configHandler((h) => {
                    h.on('getDataSrv', '-relay-', () => {
                        return peer.connectionInfo.connectedRelay;
                    });

                    h.onEvent('callbackSrv', 'response', (args) => {
                        const [res] = args;
                        resolve(res);
                    });

                    h.onEvent('errorHandlingSrv', 'error', (args) => {
                        const [err] = args;
                        reject(err);
                    });
                })
                .handleScriptError(reject)
                .handleTimeout(() => {
                    reject('Request timed out for getHistory');
                });
            if (config && config.ttl) {
                r.withTTL(config.ttl);
            }
            request = r.build();
        },
    );
    peer.internals.initiateFlow(request!);
    return promise;
}

export function initAfterJoin(
    me: { name: string; peer_id: string; relay_id: string },
    config?: { ttl?: number },
): Promise<{ name: string; peer_id: string; relay_id: string }[]>;
export function initAfterJoin(
    peer: FluencePeer,
    me: { name: string; peer_id: string; relay_id: string },
    config?: { ttl?: number },
): Promise<{ name: string; peer_id: string; relay_id: string }[]>;
export function initAfterJoin(...args: any) {
    let peer: FluencePeer;
    let me: any;
    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        me = args[1];
        config = args[2];
    } else {
        peer = FluencePeer.default;
        me = args[0];
        config = args[1];
    }

    let request: RequestFlow;
    const promise = new Promise<{ name: string; peer_id: string; relay_id: string }[]>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (seq
       (seq
        (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
        (call %init_peer_id% ("getDataSrv" "me") [] me)
       )
       (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
      )
      (call -relay- ("op" "noop") [])
     )
     (xor
      (seq
       (call -relay- ("op" "noop") [])
       (call app.$.user_list.peer_id! (app.$.user_list.service_id! "get_users") [] allUsers)
      )
      (seq
       (call -relay- ("op" "noop") [])
       (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
      )
     )
    )
    (call -relay- ("op" "noop") [])
   )
   (fold allUsers.$.users! user
    (par
     (seq
      (seq
       (seq
        (call -relay- ("op" "noop") [])
        (xor
         (call user.$.relay_id! ("peer" "is_connected") [user.$.peer_id!] isOnline)
         (seq
          (call -relay- ("op" "noop") [])
          (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
         )
        )
       )
       (call -relay- ("op" "noop") [])
      )
      (par
       (seq
        (call -relay- ("op" "noop") [])
        (xor
         (match isOnline true
          (xor
           (xor
            (call user.$.peer_id! ("fluence/fluent-pad/status" "notifyUserAdded") [me true])
            (seq
             (seq
              (seq
               (call user.$.relay_id! ("op" "noop") [])
               (call -relay- ("op" "noop") [])
              )
              (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
             )
             (call -relay- ("op" "noop") [])
            )
           )
           (seq
            (seq
             (call user.$.relay_id! ("op" "noop") [])
             (call -relay- ("op" "noop") [])
            )
            (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 4])
           )
          )
         )
         (null)
        )
       )
       (seq
        (call -relay- ("op" "noop") [])
        (call %init_peer_id% ("fluence/fluent-pad/status" "notifyUserAdded") [user isOnline])
       )
      )
     )
     (seq
      (call -relay- ("op" "noop") [])
      (next user)
     )
    )
   )
  )
  (xor
   (call %init_peer_id% ("callbackSrv" "response") [allUsers.$.users!])
   (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 5])
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 6])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });
                h.on('getDataSrv', 'me', () => {
                    return me;
                });
                h.onEvent('callbackSrv', 'response', (args) => {
                    const [res] = args;
                    resolve(res);
                });

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for initAfterJoin');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return promise;
}

export function updateOnlineStatuses(config?: { ttl?: number }): Promise<void>;
export function updateOnlineStatuses(peer: FluencePeer, config?: { ttl?: number }): Promise<void>;
export function updateOnlineStatuses(...args: any) {
    let peer: FluencePeer;

    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        config = args[1];
    } else {
        peer = FluencePeer.default;
        config = args[0];
    }

    let request: RequestFlow;
    const promise = new Promise<void>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
      (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
     )
     (call -relay- ("op" "noop") [])
    )
    (xor
     (seq
      (call -relay- ("op" "noop") [])
      (call app.$.user_list.peer_id! (app.$.user_list.service_id! "get_users") [] allUsers)
     )
     (seq
      (call -relay- ("op" "noop") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
     )
    )
   )
   (call -relay- ("op" "noop") [])
  )
  (fold allUsers.$.users! user
   (par
    (seq
     (seq
      (seq
       (seq
        (seq
         (call -relay- ("op" "noop") [])
         (call user.$.relay_id! ("op" "noop") [])
        )
        (xor
         (call user.$.peer_id! ("peer" "is_connected") [user.$.peer_id!] isOnline)
         (seq
          (seq
           (seq
            (call user.$.relay_id! ("op" "noop") [])
            (call -relay- ("op" "noop") [])
           )
           (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
          )
          (call -relay- ("op" "noop") [])
         )
        )
       )
       (call user.$.relay_id! ("op" "noop") [])
      )
      (call -relay- ("op" "noop") [])
     )
     (call %init_peer_id% ("fluence/fluent-pad/status" "notifyOnline") [user.$.peer_id! isOnline])
    )
    (seq
     (call -relay- ("op" "noop") [])
     (next user)
    )
   )
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });

                h.onEvent('callbackSrv', 'response', (args) => {});

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for updateOnlineStatuses');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return Promise.race([promise, Promise.resolve()]);
}

export function getUserList(config?: { ttl?: number }): Promise<{ name: string; peer_id: string; relay_id: string }[]>;
export function getUserList(
    peer: FluencePeer,
    config?: { ttl?: number },
): Promise<{ name: string; peer_id: string; relay_id: string }[]>;
export function getUserList(...args: any) {
    let peer: FluencePeer;

    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        config = args[1];
    } else {
        peer = FluencePeer.default;
        config = args[0];
    }

    let request: RequestFlow;
    const promise = new Promise<{ name: string; peer_id: string; relay_id: string }[]>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
      (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
     )
     (call -relay- ("op" "noop") [])
    )
    (xor
     (seq
      (call -relay- ("op" "noop") [])
      (call app.$.user_list.peer_id! (app.$.user_list.service_id! "get_users") [] allUsers)
     )
     (seq
      (call -relay- ("op" "noop") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
     )
    )
   )
   (call -relay- ("op" "noop") [])
  )
  (xor
   (call %init_peer_id% ("callbackSrv" "response") [allUsers.$.users!])
   (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });

                h.onEvent('callbackSrv', 'response', (args) => {
                    const [res] = args;
                    resolve(res);
                });

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for getUserList');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return promise;
}

export function leave(config?: { ttl?: number }): Promise<void>;
export function leave(peer: FluencePeer, config?: { ttl?: number }): Promise<void>;
export function leave(...args: any) {
    let peer: FluencePeer;

    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        config = args[1];
    } else {
        peer = FluencePeer.default;
        config = args[0];
    }

    let request: RequestFlow;
    const promise = new Promise<void>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (seq
       (seq
        (seq
         (seq
          (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
          (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
         )
         (call -relay- ("op" "noop") [])
        )
        (xor
         (seq
          (call -relay- ("op" "noop") [])
          (call app.$.user_list.peer_id! (app.$.user_list.service_id! "leave") [%init_peer_id%] res)
         )
         (seq
          (call -relay- ("op" "noop") [])
          (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
         )
        )
       )
       (call -relay- ("op" "noop") [])
      )
      (call %init_peer_id% ("fluence/get-config" "getApp") [] app0)
     )
     (call -relay- ("op" "noop") [])
    )
    (xor
     (seq
      (call -relay- ("op" "noop") [])
      (call app0.$.user_list.peer_id! (app0.$.user_list.service_id! "get_users") [] allUsers)
     )
     (seq
      (call -relay- ("op" "noop") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
     )
    )
   )
   (call -relay- ("op" "noop") [])
  )
  (fold allUsers.$.users! user
   (par
    (seq
     (call user.$.relay_id! ("op" "noop") [])
     (xor
      (call user.$.peer_id! ("fluence/fluent-pad/status" "notifyUserRemoved") [%init_peer_id%])
      (seq
       (seq
        (call user.$.relay_id! ("op" "noop") [])
        (call -relay- ("op" "noop") [])
       )
       (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
      )
     )
    )
    (seq
     (call -relay- ("op" "noop") [])
     (next user)
    )
   )
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 4])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });

                h.onEvent('callbackSrv', 'response', (args) => {});

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for leave');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return Promise.race([promise, Promise.resolve()]);
}

export function join(
    user: { name: string; peer_id: string; relay_id: string },
    config?: { ttl?: number },
): Promise<{ err_msg: string; ret_code: number }>;
export function join(
    peer: FluencePeer,
    user: { name: string; peer_id: string; relay_id: string },
    config?: { ttl?: number },
): Promise<{ err_msg: string; ret_code: number }>;
export function join(...args: any) {
    let peer: FluencePeer;
    let user: any;
    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        user = args[1];
        config = args[2];
    } else {
        peer = FluencePeer.default;
        user = args[0];
        config = args[1];
    }

    let request: RequestFlow;
    const promise = new Promise<{ err_msg: string; ret_code: number }>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (seq
       (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
       (call %init_peer_id% ("getDataSrv" "user") [] user)
      )
      (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
     )
     (call -relay- ("op" "noop") [])
    )
    (xor
     (seq
      (call -relay- ("op" "noop") [])
      (call app.$.user_list.peer_id! (app.$.user_list.service_id! "join") [user] res)
     )
     (seq
      (call -relay- ("op" "noop") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
     )
    )
   )
   (call -relay- ("op" "noop") [])
  )
  (xor
   (call %init_peer_id% ("callbackSrv" "response") [res])
   (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });
                h.on('getDataSrv', 'user', () => {
                    return user;
                });
                h.onEvent('callbackSrv', 'response', (args) => {
                    const [res] = args;
                    resolve(res);
                });

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for join');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return promise;
}

export function auth(config?: {
    ttl?: number;
}): Promise<{ err_msg: string; is_authenticated: boolean; ret_code: number }>;
export function auth(
    peer: FluencePeer,
    config?: { ttl?: number },
): Promise<{ err_msg: string; is_authenticated: boolean; ret_code: number }>;
export function auth(...args: any) {
    let peer: FluencePeer;

    let config: any;
    if (args[0] instanceof FluencePeer) {
        peer = args[0];
        config = args[1];
    } else {
        peer = FluencePeer.default;
        config = args[0];
    }

    let request: RequestFlow;
    const promise = new Promise<{ err_msg: string; is_authenticated: boolean; ret_code: number }>((resolve, reject) => {
        const r = new RequestFlowBuilder()
            .disableInjections()
            .withRawScript(
                `
     (xor
 (seq
  (seq
   (seq
    (seq
     (seq
      (call %init_peer_id% ("getDataSrv" "-relay-") [] -relay-)
      (call %init_peer_id% ("fluence/get-config" "getApp") [] app)
     )
     (call -relay- ("op" "noop") [])
    )
    (xor
     (seq
      (call -relay- ("op" "noop") [])
      (call app.$.user_list.peer_id! (app.$.user_list.service_id! "is_authenticated") [] res)
     )
     (seq
      (call -relay- ("op" "noop") [])
      (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 1])
     )
    )
   )
   (call -relay- ("op" "noop") [])
  )
  (xor
   (call %init_peer_id% ("callbackSrv" "response") [res])
   (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 2])
  )
 )
 (call %init_peer_id% ("errorHandlingSrv" "error") [%last_error% 3])
)

                 `,
            )
            .configHandler((h) => {
                h.on('getDataSrv', '-relay-', () => {
                    return peer.connectionInfo.connectedRelay;
                });

                h.onEvent('callbackSrv', 'response', (args) => {
                    const [res] = args;
                    resolve(res);
                });

                h.onEvent('errorHandlingSrv', 'error', (args) => {
                    const [err] = args;
                    reject(err);
                });
            })
            .handleScriptError(reject)
            .handleTimeout(() => {
                reject('Request timed out for auth');
            });
        if (config && config.ttl) {
            r.withTTL(config.ttl);
        }
        request = r.build();
    });
    peer.internals.initiateFlow(request!);
    return promise;
}
